<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:xalan="http://xml.apache.org/xalan"
 xmlns:redirect="http://xml.apache.org/xalan/redirect"
 exclude-result-prefixes="xalan"
 extension-element-prefixes="redirect">

 <xsl:include href="xradar://stylesheets/radar/statics/graph/scatter-graph.xsl"/>

<xsl:template match="IntegratedAnalysis" mode="abstractness-instability-graph">
  <xsl:variable name="rtf-point-nodeset">
   <points>
		<xsl:for-each select="Packages/Package[Stats/source-classes-analyzed > 0]/Stats">
			<xsl:element name="point">
				<xsl:element name="x-coordinate">
					<xsl:copy-of select="I"/>
				</xsl:element>
				<xsl:element name="y-coordinate">
					<xsl:copy-of select="A"/>
				</xsl:element>
			</xsl:element>
		</xsl:for-each>
   </points>
  </xsl:variable>

  <xsl:variable name="rtf-graph-additions">
    <g stroke="green" >
	    <line x1="100" y1="200" x2="1100" y2="1200"
	            stroke-width="4" />
	    <line x1="100" y1="400" x2="900" y2="1200"
	            stroke-dasharray="20 10" stroke-width="2" />
	     <line x1="200" y1="100" x2="1200" y2="1100"
	            stroke-dasharray="20 10" stroke-width="2" />
  	</g>
  </xsl:variable>

  <xsl:call-template name="scatter-graph">
  	<xsl:with-param name="text-x-axis">
  		Instability
  	</xsl:with-param>
  	<xsl:with-param name="text-y-axis">
  		Abstractness
  	</xsl:with-param>
   <xsl:with-param name="main-sequence">
        Main sequence
   </xsl:with-param>
  	<xsl:with-param name="point-nodeset" select="$rtf-point-nodeset"/>
	<xsl:with-param name="graph-additions" select="$rtf-graph-additions"/>
  </xsl:call-template>


</xsl:template>

</xsl:stylesheet>
