<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:xalan="http://xml.apache.org/xalan"
 xmlns:redirect="http://xml.apache.org/xalan/redirect"
 extension-element-prefixes="redirect">

 <xsl:import href="xradar://stylesheets/radar/statics/graph/scatter-graph.xsl"/>

<xsl:template match="IntegratedAnalysis" mode="aggregatesourcestatements-packagenumber-graph">
  <xsl:variable name="total-packages">    
    <xsl:value-of select="count(Packages/Package[Stats/source-classes-analyzed > 0])"/>      
  </xsl:variable>
  
  <xsl:variable name="aggregated-ncss">
    <xsl:value-of select="sum(Packages/Package/Stats/ncss)"/>
  </xsl:variable>
  
  <xsl:variable name="rtf-sorted-nodeset">
   <xsl:for-each select="Packages/Package[Stats/source-classes-analyzed > 0]/Stats">
    <xsl:sort select="ncss" order="descending" data-type="number"/>
    	<xsl:copy-of select="."/>
   </xsl:for-each>
  </xsl:variable>
    
   
  <xsl:variable name="rtf-point-nodeset">
   	<points>   		
		<xsl:for-each select="xalan:nodeset($rtf-sorted-nodeset)/*">    		
			<xsl:element name="point">
				<xsl:element name="x-coordinate">
					<xsl:copy-of select="count((.|preceding-sibling::Stats)) div $total-packages"/>
				</xsl:element>
				<xsl:element name="y-coordinate">
					<xsl:copy-of select="sum((.|preceding-sibling::Stats)/ncss) div $aggregated-ncss"/>
				</xsl:element>    		
			</xsl:element>
		</xsl:for-each>   
   </points>
  </xsl:variable>
  
    
  <xsl:variable name="rtf-graph-additions">    
	  
  </xsl:variable>
  
  <xsl:call-template name="scatter-graph">
  	<xsl:with-param name="text-x-axis">
    	Packages
  	</xsl:with-param>
  	<xsl:with-param name="text-y-axis">
  	    Aggregated Source Statements
  	</xsl:with-param>
  	<xsl:with-param name="point-nodeset" select="$rtf-point-nodeset"/>
	<xsl:with-param name="graph-additions" select="$rtf-graph-additions"/>  	 	  		
	<xsl:with-param name="include-grid-lines" select="'true'"/>	
	<xsl:with-param name="include-pareto-lines" select="'true'"/>	
  </xsl:call-template> 
 

</xsl:template>

</xsl:stylesheet> 
